char i = 0;

/*unsigned char sin_table_0_180[32]={0, 25, 49, 73, 96, 118, 137, 159, 177, 193, 208, 220, 231, 239, 245, 249, 250,
                             249, 245, 239, 231, 220, 208, 193, 177, 159, 137, 118, 96, 73, 49, 25};     */
                             
unsigned char sin_table_0_180[33]={123,135,145,156,167,176,186,194,203,210,216,222,227,231,233,235,236,235,233,231,227,222,216,210,203,194,186,176,165,156,145,135,123};

unsigned char sin_table_120_300[33]= {222,227,231,233,235,236,235,233,231,227,222,216,210,203,194,186,176,165,156,145,135,123,123,135,145,156,167,176,186,194,203,210,216};

unsigned char sin_table_300_480[33]={216,210,203,194,186,176,165,156,145,135,123,123,135,145,156,167,176,186,194,203,210,216,222,227,231,233,235,236,235,233,231,227,222};
/*unsigned char sin_table_120_300[32]={120, 145, 169, 193, 216, 238, 259, 279, 297, 313, 328, 340, 351, 359, 365, 369,
                                     370, 369, 365, 359, 351, 340, 328, 313, 297, 279, 259, 238, 216, 193, 169, 145}; */
                             
/*unsigned char sin_table_300_480[32]={270, 295, 319, 343, 366, 388, 409, 429, 447, 463, 478, 490, 501, 509, 515, 519,
                                     520, 519, 515, 509, 501, 490, 478, 463, 447, 429, 409, 388, 366, 343, 319, 295}; */
                             
unsigned int frequency = 0;

unsigned int TBL_POINTER_NEW[3], TBL_POINTER_OLD[3], TBL_POINTER_SHIFT[3], SET_FREQ;
unsigned char DUTY_CYCLE[3];

void interrupt(){
     if (TMR2IF_bit == 1) {
        TBL_POINTER_NEW[0] = TBL_POINTER_OLD[0] + SET_FREQ ;
        if (TBL_POINTER_NEW[0] < TBL_POINTER_OLD[0]){
           CCP1CON.P1M1 = ~CCP1CON.P1M1; //Reverse direction of full-bridge
        }
        
        TBL_POINTER_SHIFT[0] = TBL_POINTER_NEW[0] >> 11;
        DUTY_CYCLE[0] = TBL_POINTER_SHIFT[0];
        CCPR1L = sin_table_0_180[DUTY_CYCLE[0]];
        TBL_POINTER_OLD[0] = TBL_POINTER_NEW[0];
        
        TBL_POINTER_NEW[1] = TBL_POINTER_OLD[1] + SET_FREQ;
        if (TBL_POINTER_NEW[1] < TBL_POINTER_OLD[1]){
           CCP2CON.P2M1 = ~CCP2CON.P2M1; //Reverse direction of full-bridge
        }
        
        
        TBL_POINTER_SHIFT[1] = TBL_POINTER_NEW[1] >> 11;
        DUTY_CYCLE[1] = TBL_POINTER_SHIFT[1];
        CCPR2L = sin_table_120_300[DUTY_CYCLE[1]];
        TBL_POINTER_OLD[1] = TBL_POINTER_NEW[1];
        
        TBL_POINTER_NEW[2] = TBL_POINTER_OLD[2] + SET_FREQ;
        if (TBL_POINTER_NEW[2] < TBL_POINTER_OLD[2]){
           CCP3CON.P1M1 = ~CCP3CON.P1M1; //Reverse direction of full-bridge
        }
        TBL_POINTER_SHIFT[2] = TBL_POINTER_NEW[2] >> 11;
        DUTY_CYCLE[2] = TBL_POINTER_SHIFT[2];
        CCPR3L = sin_table_300_480[DUTY_CYCLE[2]];
        TBL_POINTER_OLD[2] = TBL_POINTER_NEW[2];
        
        TMR2IF_bit = 0;
     }
}

void main() {

     Delay_ms(10);
     
     //APFCON = 0x2E;
     APFCON = 0xFF;
     
     ADCON1 = 0b00100000;
     FVRCON = 0x00;
     
     ANSELA = 0x01;
     ANSELB = 0x00;

     CM1CON0 = 0x00;
     CM2CON0 = 0x00;
     
     TRISA = 0x00;

     PORTA = 0x00;
     PORTB = 0x00;
     PORTC = 0x00;
     
     LATA = 0x00;
     LATB = 0x00;
     LATC = 0x00;
     
     SET_FREQ = 287;
     
     for(i = 0; i < 3; i++) {
         TBL_POINTER_SHIFT[i] = 0;
         TBL_POINTER_NEW[i] = 0;
         TBL_POINTER_OLD[i] = 0;
         DUTY_CYCLE[i] = 0;
     }

     PR2 = 410;
     TRISB = 0xFF;
     TRISC = 0xFF;
     
     PWM1_Init(16000);
     PWM2_Init(16000);
     PWM3_Init(16000);

     PWM1_Set_Duty(0);
     PWM2_Set_Duty(0);
     PWM3_Set_Duty(0);

     PWM1_Start();
     PWM2_Start();
     PWM3_Start();
     
     TMR2IF_bit = 0;
     T2CON = 4;
     while(TMR2IF_bit == 0);
     TMR2IF_bit = 0;
     
     TRISB = 0x00;
     TRISC = 0x00;
     
     TMR2IE_bit = 1;
     PEIE_bit = 1;
     GIE_bit = 1;
     while(1) {
     
     }
}